#include <stdlib.h>
#include <string.h>

/*-----------------------------------------------------------------------------
 * implementation of hbook-interface for C - straight translations
 *---------------------------------------------------------------------------*/


void hlimit(int nspace) 
{
  hlimit_(&nspace);
  return;
}

void hbook1(int id, char *title, int nbin, float xl, float xh)
{
  float dummy=0.;
  hbook1_(&id, title, &nbin, &xl, &xh, &dummy, strlen(title));
  return;
}

void hbook2(int id, char *title, int nbin1, float xl1, float xh1,
                                int nbin2, float xl2, float xh2)
{
  float dummy = 0.;
  hbook2_(& id, title, & nbin1, &xl1, &xh1, & nbin2, &xl2, &xh2, &dummy,
	  strlen(title));
  return;
}

void hbprof(int id, char *title, int nbin1, float xl1, float xh1,
                                           float xl2, float xh2, char * opt)
{
  hbprof_(& id, title, & nbin1, & xl1, & xh1, & xl2, & xh2, opt,
	  strlen(title), strlen(opt));
  return;
}

void hf1 (int id, float x, float weight)
{
  hf1_(&id, &x, &weight);
  return;
}

void hf2 (int id, float x1, float x2, float weight)
{
  hf2_(&id, &x1, &x2, &weight);
  return;
}

void hfill (int id, float x, float y, float weight)
{
  hfill_ ( & id, & x, & y, & weight );
  return;
}

void hrput (int i, char * fn, char * md)
{
  hrput_ (&i, fn, md, strlen(fn), strlen(md));
}

void hpak(int id, float * data)
{
  hpak_(&id, data);
  return;
}

void hpake(int id, float * data)
{
  hpake_(&id, data);
  return;
}

void hpakad(int id, float * data)
{
  hpakad_(&id, data);
  return;
}

void hminim(int id, float val)
{
  hminim_(&id, &val);
  return;
}

void hmaxim(int id, float val)
{
  hmaxim_(&id, &val);
  return;
}

void hdelet(int id)
{
  hdelet_(&id);
  return;
}

void hprint(int id)
{
  hprint_(&id);
  return;
}

int hexist(int id)
{
  return hexist_(&id);
}

void hfn (int id, float arr[])
{
  hfn_ ( & id, arr );
  return;
}

void hopera (int id1, char * op, int id2, int id3, float scale1, float scale2)
{
  hopera_ ( & id1, op, & id2, & id3, & scale1, & scale2, strlen(op) );
  return;
}


void hreset (int id, char * chtitl) 
{
  hreset_ (& id, chtitl, strlen (chtitl));
  return;
}

float hsum_(int*);

float hsum (int id) {
  float res;
  res = hsum_ (&id);
  return (res);
}


/*-----------------------------------------------------------------------------
 * higher level adaption(s) and/or modifications
 *---------------------------------------------------------------------------*/

void hproj1(int id, int idn, int ivar)
/*-----------------------------------------------------------------------------
 * project one variable from an n-tuple into a histogram
 *---------------------------------------------------------------------------*/
{
  int isel   =       0;  /* no selection              */
  int uwfunc =       1;  /* dummy                     */
  int ifrom  =       1;  /* first entry               */
  int ito    = 9999999;  /* more entries are unlikely */ 
/*---------------------------------------------------------------------------*/

  hproj1_(&id, &idn, &isel, &uwfunc, &ifrom, &ito, &ivar);
  return; 
}


void hbookn (int id, char * title, char * topdir, char tags[])
/*-----------------------------------------------------------------------------
 * modified subroutine hbookn: the number of variables in the ntuple
 * and the  tags for all variables are extracted from the string tags[]
 *
 * Author: Joerg Rieling / Michael Schmelling 
 *---------------------------------------------------------------------------*/
{
  int n=0;
  int l=0, j=0;
  int elli = 0;
  char * c;
  char * calloc;
  int bufsiz = 1000;

  for (c=tags; *c != '\0'; c += 1)
    if (!strncmp( c, ",", 1)) 
    {
      n++;
      if (!elli) { printf ("hbookn > idiot !\n"); exit (999); }
      if (l<elli) l = elli;
      elli = 0;
    }
    else
    {
      elli++;
    }

  calloc = malloc ((l*(n+1)+1) *  sizeof(char));
  j = elli = 0;

  for (c=tags; *c != '\0'; c += 1)
    if (!strncmp( c, ",", 1)) 
    {
      while (elli<l)
      {
	calloc[j++] = *" ";
	elli++;
      }
      elli = 0;
    }
    else
    {
      calloc[j++] = *c;
      elli++;
    }

  while (elli<l)
  {
    calloc[j++] = *" ";
    elli++;
  }

  calloc [j] = '\0';
  n++;

  hbookn_ (& id, title, & n, topdir, & bufsiz, calloc, strlen(title),
	   strlen(topdir), l);

  free ((void *) calloc);

  return;
}







