# include <string.h>

/*-----------------------------------------------------------------------------
 * interface of FORTAN higz/hplot/gks/X11 stuff to C 
 *---------------------------------------------------------------------------*/

void hplint(int iwk)
{
  hplint_(&iwk);
}

void hplend()
{   
  hplend_();
} 

void hplot(int id,char *chopt,char *select, int num)
{
  hplot_(&id, chopt, select, &num, strlen(chopt), strlen(select));
}

void hplopt(char *chopt)
{
  int one=1;
  hplopt_(chopt, &one, strlen(chopt));
}

void hplzon(int nx, int ny, int first, char *chopt)
{
  hplzon_(&nx, &ny, &first, chopt, strlen(chopt));
}

void hplset(char *chopt, float val)
{
  hplset_(chopt, &val, strlen(chopt));
}

void iginit(int iwk)
{
  iginit_(&iwk) ;
} 

void igend()
{ 
  igend_();
}

void igterm()
{
  igterm_();
}

void hpline(float xval[], float yval[], int n, char *chopt)
{
  hpline_(xval, yval, & n, chopt, strlen(chopt));
}

void hplbox (float x1, float y1, float x2, float y2, char * chopt)
{
  /*  printf("%f %f %f %f %s %d\n",x1,y1,x2,y2,chopt,strlen(chopt)); */
  hplbox_ (& x1, & y1, & x2, & y2, chopt, strlen(chopt));
}

void ifa (int n, float x[], float y[])
{
  ifa_ (& n, x, y);
  return;
}

void hplfra (float x1, float x2, float y1, float y2, char * chopt)
{
  hplfra_ ( & x1, & x2, & y1, & y2, chopt, strlen(chopt));
  return;
}

void igset (char * what, float value)
{
  igset_ (what, & value, strlen(what));
  return;
}

void hplsof (float x, float y, char * what, float size,
	     float angle, int iopt)
{
  float idiot=0;
  hplsof_ (& x, & y, what, & size, & angle, &idiot, &iopt,
	   strlen(what));
  return;
}


void igtext (float x, float y, char * what, float size,
	     float angle, char * chopt)
{
  igtext_ (& x, & y, what, & size, & angle, chopt,
	   strlen(what),strlen(chopt));
  return;
}


void iclrwk (int kw, int ko)
{
  iclrwk_ ( & kw, & ko );
  return;
}

void igarc (float x, float y, float r1, float r2, float p1, float p2)
{
  hplarc_  ( & x, & y, & r1, & r2, & p1, & p2);
  return;
}

void igaxis(float xmi, float xma, float ymi, float yma,
            float wmi, float wma, int ndiv , char * chopt)
{
  igaxis_(& xmi, & xma, & ymi, & yma,
	  & wmi, & wma, & ndiv , chopt, strlen(chopt));
}

void igzset (char * c)
{
  igzset_ ( c, strlen(c) );
  return;
}

void izfile (int i, char * c1, char * c2)
{
  izfile_ ( & i, c1, c2, strlen(c1), strlen(c2) );
  return;
}

void hplcap (int file) 
{
  hplcap_ ( & file );
  return;
}


void hplsym(float x0, float y0, int n, int symb, float size, char* chopt) 
{
  hplsym_ (&x0, &y0, &n, &symb, &size, chopt, strlen(chopt));
  return;
}


int ixopnds(char* display)
{
  int lstr;  /* length of the display string */
  lstr = strlen(display);
  return ixopnds_(&lstr, display, lstr);
}

void ixselwi(int iwin)
{
  ixselwi_(&iwin);
  return;
}


void ixclswi()
{
  ixclswi_();
  return;
}


void ixrscwi(int iwin, int iw, int ih)
{
  ixrscwi_(&iwin, &iw, &ih);
  return;
}

void ixupdwi(int iwin)
{
  ixupdwi_(&iwin);
  return;
}

void ixsetlc(int index)
{
  ixsetlc_(&index);
  return;
}

void ixsetco(int index, int r, int g, int b)
{
  ixsetco_(&index, &r, &g, &b);
  return;
}

/*-----------------------------------------------------------------------------
 * (higher level) user defined macros
 *---------------------------------------------------------------------------*/
 
void hplnt(int id, int ivarx, int ivary)
/*-----------------------------------------------------------------------------
 * plot 2 variables from an n-tuple into the current normalization transform
 *---------------------------------------------------------------------------*/
{
  int isel   =      0;   /* no selection           */
  int uwfunc =      1;   /* dummy                  */
  int ifrom  =      1;   /* start at the beginning */
  int ito    = 999999;   /* more is unlikely       */
/*---------------------------------------------------------------------------*/

  hplnt_(&id, &isel, &uwfunc, &ifrom, &ito, &ivarx, &ivary); 
  return;
}

int ixopnwi(int ix, int iy, int iw, int ih, char* text)
/*-----------------------------------------------------------------------------
 * open an X11 window at position (ix,iy) with (width,height)=(iw,ih) 
 *---------------------------------------------------------------------------*/
{
  int lstr;    /* length of the title */
  int flag=0;  /* flag of unknown use */
/*---------------------------------------------------------------------------*/

  lstr = strlen(text);
  return ixopnwi_(&ix, &iy, &iw, &ih, &lstr, text, &flag, lstr);  
}




void hpbeam (float xlowleft, float ylowleft, float xrightup, float yrightup)
{
  float x[2], y[2];

  x[0] = xlowleft; x[1] = xrightup;
  y[0] = ylowleft; y[1] = yrightup;
  hpline (x, y, 2, " ");

  return;
}

void hpcoos (float x1, float y1, float x2, float y2, char * chopt)
{
  hplfra_ ( & x1, & x2, & y1, & y2, chopt, strlen(chopt));
  return;
}

void polyplot (float x, float y)
{
  int one = 1;
  ipm_ (& one, & x, & y);
  return;
}
void hpdot (float x, float y)
{
  int one      = 1;
  int zero     = 0;
  float size   = .1;
  char * chopt = " ";
  hplsym_ (& x, & y, & one, & zero, & size, " ", strlen(chopt));
  return;
}


void igsse(int ierrf, int kwtype)
{
  igsse_(&ierrf, &kwtype);
  return;
}

void ixclip(int iwid, int ix, int iy, int iw, int ih)
{
  ixclip_(&iwid, &ix, &iy, &iw, &ih);
}

void ixnocli(int iwid)
{
  ixnocli_(&iwid);
}

void iswkwn(int kwkid, float xmin, float xmax, float ymin, float ymax)
{
  iswkwn_(&kwkid, &xmin, &xmax, &ymin, &ymax);
}

void iswkvp(int kwkid, float xmin, float xmax, float ymin, float ymax)
{
  iswkvp_(&kwkid, &xmin, &xmax, &ymin, &ymax);
}

void ixmovwi(int iwid, int x, int y)
{
  ixmovwi_(&iwid, &x, &y);
}

void igrng(float xsize, float ysize)
{
  igrng_(&xsize, &ysize);
}

void igbox(float x1, float x2, float y1, float y2)
{
  igbox_(&x1, &x2, &y1, &y2);
}

void iswn(int nt, float xmin, float xmax, float ymin, float ymax)
{
  iswn_(&nt, &xmin, &xmax, &ymin, &ymax);
}

void isvp(int nt, float xmin, float xmax, float ymin, float ymax)
{
  isvp_(&nt, &xmin, &xmax, &ymin, &ymax);
}

void igsa(int kwkid)
{
  igsa_(&kwkid);
}

void iopwk(int kwkid, int konid, int kwtype)
{
  iopwk_(&kwkid, &konid, &kwtype);
}

void iacwk(int kwkid)
{
  iacwk_(&kwkid);
}

void idawk(int kwkid)
{
  idawk_(&kwkid);
}

void iuwk(int kwkid, int irflg)
{
  iuwk_(&kwkid, &irflg);
}

void itx(float x, float y, char *chars)
{
  itx_(&x, &y, chars);
}

void ixbox(int ix1, int ix2, int iy1, int iy2, int mode)
{
  ixbox_(&ix1, &ix2, &iy1, &iy2, &mode);
}

void ixclsds(void)
{
  ixclsds_();
}

void iclwk(int kwkid)
{
  iclwk_(&kwkid);
}
