
#include <iostream.h>
#include <cstring>

#include "grr.h"

#include "aframelib.h"
#include "iol.h"
#include "itrleda.h"

#include "itrMAP.h"


int main (int argc, char* argv[]) {
  int dbmajor, dbminor, i, rc;
  char *routine="main";
  
  aframe_store_program_name(argv[0]); 
  aframe_param_init();
  iol_param_init();
  ITR_leda_param_init();
 
  /* get command line arguments indicating database table */
  dbmajor = 13400;
  dbminor = 1;

  for (i = 1; i < argc; i++) {
    if (!strncmp (argv[i], "-dbmajor:", 9)) 
      sscanf (&argv[i][9], "%d", &dbmajor);
    if (!strncmp (argv[i], "-dbminor:", 9))
      sscanf (&argv[i][9], "%d", &dbminor);
  }
  iol_scan_preferences_from_db ("/ITR_Setup:ITR/Steering", dbmajor, dbminor);

  /* now load file, if +P command line argument given */
  if ( aframe_process_args(argc, (const char**)argv, AFRAME_CLI) != AFRAME_OK ) {
    aframe_mess(routine,GRR_SFATAL,"Error processing arguments.");
    return GRR_FISHY;
  }
  
  rc  = ITR_leda_initialize (itrleda_CheckDD_ALWAYS);
  rc |= ITR_leda_startprogram( 7, 3 );
  if ( rc != GRR_OK ) return rc;

  int nmap;

  itrslt_fillMAP (&nmap);

  itrslt_testMAP ();

}
